//
//  ViewController.h
//
//  Created by Vjekoslav Ranogajec on 01/10/2020.
//  Copyright © 2020 Visage Technologies AB. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "AKPickerView.h"
#import "StringMessageButton.h"
#import "CameraGrabber.h"
#import "MakeupSDK/MakeUpEngine.h"

@interface ViewController : UIViewController

-(void) activateLook:(int) lookIndex;
-(void) refreshMakeup;

@end


@interface SortedDict: NSObject {}

- (id) Get: (id) key;
- (void) Set: (id) key object:(id) object;
- (id)initWithDict:(NSMutableDictionary*) dict andRawJSON:(NSString*) rawJSON;

@property NSArray* sortedKeys;
@property NSMutableDictionary* dict;

@end

@interface PickerViewDataProvider:NSObject<AKPickerViewDataSource>
{
    ViewController* controller;
}
- (id) initWithController:(ViewController*) controller;
@end

@interface PickerViewDataProviderRegion:PickerViewDataProvider {}
@end

@interface PickerViewDataProviderLooks:PickerViewDataProvider {}
- (id)initWithController:(ViewController*)controller andDataSource:(SortedDict*) _dataSource;
@end


@interface PickerViewDelegate:NSObject<AKPickerViewDelegate>
{
    ViewController* controller;
}
- (id)initWithController:(ViewController*)controller;
@end

@interface PickerViewDelegateLooks:PickerViewDelegate {}
@end

@interface EffectObserver : NSObject <IMakeUpObserver>
- (void)OnStart:(MakeUpEngine *)sender;
- (void)OnEffectCreated:(MakeUpEngine*)sender :(Effect*)effect;
- (void)OnEffectUpdated:(MakeUpEngine*)sender :(Effect*)effect;
- (void)OnClear:(MakeUpEngine*)sender;
- (void)OnEffectHidden:(MakeUpEngine*)sender :(Effect*)effect;
- (void)OnEffectDisplayed:(MakeUpEngine*)sender :(Effect*)effect;
- (void)OnEffectRemoved:(MakeUpEngine*)sender :(Effect*)effect;

@end

