#pragma once
#include "FrameProvider/Image.h"
#include <functional>

namespace fpr {
class IPromiseResolver;

class FRAMEPROVIDER_EXPORT IFrameObserver {
    public:
    /**
     * When a FrameProvider this observer is subscribed to queues a new frame, it will invoke this method.
     * @param id Sequential index of the queued frame.
     * @param frame Frame that was just queued.
     * @param resolver Use Resolve method to callback that the frame is no longer needed.
     */
    virtual void Notify(long id, const CamIL::Image& frame, IPromiseResolver& resolver) = 0;
};

} // namespace fpr
