#import "IMakeUpObserver.h"

@interface InternalMakeUpObserver : NSObject <IMakeUpObserver>
/**
 * Callback method invoked when the application is started
 * @param sender an instance of makeup engine
 */
- (void)OnStart:(MakeUpEngine*)sender;

/**
 * Callback method invoked when creation of makeup effect is completed
 * @param sender an instance of makeup engine
 * @param effect created effect
 */
- (void)OnEffectCreated:(MakeUpEngine*)sender :(Effect*)effect;

/**
 * Callback method invoked when destruction of makeup effect is completed
 * @param sender an instance of makeup engine
 * @param effect destroyed effect
 */
- (void)OnEffectRemoved:(MakeUpEngine*)sender :(Effect*)effect;

/**
 * Callback method invoked when hidding of makeup effect is completed
 * @param sender an instance of makeup engine
 * @param effect hidden effect
 */
- (void)OnEffectHidden:(MakeUpEngine*)sender :(Effect*)effect;

/**
 * Callback method invoked when display of makeup effect is completed
 * @param sender an instance of makeup engine
 * @param effect displayed effect
 */
- (void)OnEffectDisplayed:(MakeUpEngine*)sender :(Effect*)effect;

/**
 * Callback method invoked when all makeup effects are cleared
 * @param sender an instance of makeup engine
 */
- (void)OnClear:(MakeUpEngine*)sender;
@end
