#import "FrameProvider/FrameProvider.h"
#import "MakeUpEngine.h"

/**
 *  Provides all MakeupSDK modules.
 *
 */
@interface SDKProvider : NSObject {
}

/**
  * Gets or creates a SDKProvider singleton instance.
  *
  * @param licensePath   Path to the license.
  * @return              SDKProvider singleton.
  */
+ (SDKProvider *)GetProvider:(NSString *)licensePath;

/**
 * Gets the FrameProvider instance.
 * Use this to pass frames to the makeup engine.
 * @return              FrameProvider instance from the singleton.
 */
- (fpr::FrameProvider *)GetFrameProvider;


/**
 * Creates a new instance of the MakeUpEngine class.
 *
 * @return          MakeupEngine instance.
 */
- (MakeUpEngine *)CreateMakeUpEngine;

@end
